clc; clear all; close all;

L = 50; d = 3; R = 85.2; MM = 18.126484999; 
conv1 = 0.555556; %rankine to kelvin
conv2 = 6894.76; %psi to Pa
conv3 = 144; %ft^2 to in^2
conv4 = 0.00755987; %lbm/min to kg/s
conv5 = 17497.204729; %kg^2/s^2 to lb^2/min^2
conv6 = 2.1983696645E-6; %miles-lbm-lbf/(ft^4-min^2) to psi^2
conv7 = 0.3048; %ft to m

T = 519.67; %rankine
q = 4148.957; %lb/min
P1 = 127.4786; %psi

ff = ff_Sim(d*conv7, q*conv4);

zeta = ff*(q*conv4)^2;

error = 1;
P2 = P1 - 50;
dP = 1E-3;
func = 1; 
while abs(func) > 1E-5
    P_m = (P1 + P2)/2;
    Z_m = Z_Sim(T*conv1,P_m*conv2);
    func = P1^2 - P2^2 - L*R*Z_m*T/((pi()*(d/2)^2)^2*d)*zeta*conv5*conv6;
    P_md = (P1 + P2 + dP)/2;
    Z_md = Z_Sim(T*conv1,P_md*conv2);
    func_d = P1^2 - (P2 + dP)^2 - L*R*Z_md*T/((pi()*(d/2)^2)^2*d)*zeta*conv5*conv6;
    f_prime = (func_d - func)/dP;
    P2 = max(P2 - func/f_prime, 50);
end

Output = ['Outlet pressure is ' num2str(P2,7)];
disp(Output)
