%This function calculates the difference between the guessed mixture
%density and the calculated mixture density the given temp and press, from
%the calculated compressability factor.

function Diff = Z_Diff(B_T, p_m, K, C_n_s, b_n, c_n, k_n, Press, Temp)
    R = 8314.51; %Universal Gas Constant J(kmol*K)^-1
    p_r = K^3*p_m;
    
    CT1= 0;
    for s = 13:18
        CT1 = CT1 + C_n_s(s);
    end
    
    D_n_s = zeros(1, 58);
    for s = 1:58
        D_n_s(s) = (b_n(s) - c_n(s)*k_n(s)*p_r^(k_n(s)))*p_r^(b_n(s))*exp(-c_n(s)*p_r^(k_n(s)));
    end
    
    CDT1 = 0;        
    for s = 13:58
        CDT1 = CDT1 + C_n_s(s)*D_n_s(s);
    end
        
    Z = 1 + B_T*p_m - p_r*CT1 + CDT1;
    p_m2 = Press/(R*Temp*Z);
    Diff = abs(p_m - p_m2);
end

